import { Request, Response, NextFunction } from 'express';
import { type ITagWithCountDb } from '../Interfaces';
import type { TagEntity } from '../databases/entities/TagEntity';
import { TagRepository } from '../databases/repositories';
import { TagsRequest } from '../requests';
import { ExternalHooks } from '../ExternalHooks';
export declare class TagsController {
    private tagsRepository;
    private externalHooks;
    private config;
    constructor(tagsRepository: TagRepository, externalHooks: ExternalHooks);
    workflowsEnabledMiddleware(req: Request, res: Response, next: NextFunction): void;
    getAll(req: TagsRequest.GetAll): Promise<TagEntity[] | ITagWithCountDb[]>;
    createTag(req: TagsRequest.Create): Promise<TagEntity>;
    updateTag(req: TagsRequest.Update): Promise<TagEntity>;
    deleteTag(req: TagsRequest.Delete): Promise<boolean>;
}
