"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.paginationListQueryMiddleware = void 0;
const utils_1 = require("../../utils");
function toPaginationOptions(rawTake, rawSkip) {
    const MAX_ITEMS = 50;
    if ([rawTake, rawSkip].some((i) => !(0, utils_1.isIntegerString)(i))) {
        throw new Error('Parameter take or skip is not an integer string');
    }
    const [take, skip] = [rawTake, rawSkip].map((o) => parseInt(o, 10));
    return { skip, take: Math.min(take, MAX_ITEMS) };
}
const paginationListQueryMiddleware = (req, res, next) => {
    const { take: rawTake, skip: rawSkip = '0' } = req.query;
    if (!rawTake)
        return next();
    const { take, skip } = toPaginationOptions(rawTake, rawSkip);
    req.listQueryOptions = { ...req.listQueryOptions, take, skip };
    next();
};
exports.paginationListQueryMiddleware = paginationListQueryMiddleware;
//# sourceMappingURL=pagination.js.map